Semi-Circle Sunburst in JavaScript

Using ApexCharts with JavaScript

This Semi-Circle Sunburst example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      data: [
        {
          x: 'Engineering',
          y: 46,
          children: [
            { x: 'Platform', y: 24 },
            { x: 'Product', y: 14 },
            { x: 'QA', y: 8 },
          ],
        },
        {
          x: 'Sales',
          y: 28,
          children: [
            { x: 'Field', y: 18 },
            { x: 'Inside', y: 10 },
          ],
        },
        {
          x: 'Marketing',
          y: 16,
          children: [
            { x: 'Brand', y: 9 },
            { x: 'Growth', y: 7 },
          ],
        },
        {
          x: 'Operations',
          y: 10,
          children: [
            { x: 'People', y: 6 },
            { x: 'Finance', y: 4 },
          ],
        },
      ],
    },
  ],
  chart: {
    type: 'sunburst',
    height: 360,
  },
  colors: ['#6366F1', '#0EA5E9', '#22C55E', '#F97316'],
  legend: {
    position: 'bottom',
  },
  title: {
    text: 'Annual budget allocation',
    align: 'left',
  },
  plotOptions: {
    sunburst: {
      startAngle: -90,
      endAngle: 90,
      innerSize: '30%',
      borderRadius: 4,
      spacing: 2,
    },
  },
  stroke: {
    width: 1,
    colors: ['#fff'],
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Semi-Circle Sunburst in Angular

Using ApexCharts with Angular

This Semi-Circle Sunburst example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              data: [
                {
                  x: 'Engineering',
                  y: 46,
                  children: [
                    { x: 'Platform', y: 24 },
                    { x: 'Product', y: 14 },
                    { x: 'QA', y: 8 },
                  ],
                },
                {
                  x: 'Sales',
                  y: 28,
                  children: [
                    { x: 'Field', y: 18 },
                    { x: 'Inside', y: 10 },
                  ],
                },
                {
                  x: 'Marketing',
                  y: 16,
                  children: [
                    { x: 'Brand', y: 9 },
                    { x: 'Growth', y: 7 },
                  ],
                },
                {
                  x: 'Operations',
                  y: 10,
                  children: [
                    { x: 'People', y: 6 },
                    { x: 'Finance', y: 4 },
                  ],
                },
              ],
            },
          ],
          chart: {
            type: 'sunburst',
            height: 360,
          },
          colors: ['#6366F1', '#0EA5E9', '#22C55E', '#F97316'],
          legend: {
            position: 'bottom',
          },
          title: {
            text: 'Annual budget allocation',
            align: 'left',
          },
          plotOptions: {
            sunburst: {
              startAngle: -90,
              endAngle: 90,
              innerSize: '30%',
              borderRadius: 4,
              spacing: 2,
            },
          },
          stroke: {
            width: 1,
            colors: ['#fff'],
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Semi-Circle Sunburst in Vue

Using ApexCharts with Vue

This Semi-Circle Sunburst example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="sunburst"
        height="360"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          data: [
            {
              x: 'Engineering',
              y: 46,
              children: [
                { x: 'Platform', y: 24 },
                { x: 'Product', y: 14 },
                { x: 'QA', y: 8 },
              ],
            },
            {
              x: 'Sales',
              y: 28,
              children: [
                { x: 'Field', y: 18 },
                { x: 'Inside', y: 10 },
              ],
            },
            {
              x: 'Marketing',
              y: 16,
              children: [
                { x: 'Brand', y: 9 },
                { x: 'Growth', y: 7 },
              ],
            },
            {
              x: 'Operations',
              y: 10,
              children: [
                { x: 'People', y: 6 },
                { x: 'Finance', y: 4 },
              ],
            },
          ],
        },
      ],
      chartOptions: {
        chart: {
          type: 'sunburst',
          height: 360,
        },
        colors: ['#6366F1', '#0EA5E9', '#22C55E', '#F97316'],
        legend: {
          position: 'bottom',
        },
        title: {
          text: 'Annual budget allocation',
          align: 'left',
        },
        plotOptions: {
          sunburst: {
            startAngle: -90,
            endAngle: 90,
            innerSize: '30%',
            borderRadius: 4,
            spacing: 2,
          },
        },
        stroke: {
          width: 1,
          colors: ['#fff'],
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 560px;
  margin: 35px auto;
}
</style>

Semi-Circle Sunburst in React

Using ApexCharts with React

This Semi-Circle Sunburst example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        data: [
          {
            x: 'Engineering',
            y: 46,
            children: [
              { x: 'Platform', y: 24 },
              { x: 'Product', y: 14 },
              { x: 'QA', y: 8 },
            ],
          },
          {
            x: 'Sales',
            y: 28,
            children: [
              { x: 'Field', y: 18 },
              { x: 'Inside', y: 10 },
            ],
          },
          {
            x: 'Marketing',
            y: 16,
            children: [
              { x: 'Brand', y: 9 },
              { x: 'Growth', y: 7 },
            ],
          },
          {
            x: 'Operations',
            y: 10,
            children: [
              { x: 'People', y: 6 },
              { x: 'Finance', y: 4 },
            ],
          },
        ],
      },
    ],
    options: {
      chart: {
        type: 'sunburst',
        height: 360,
      },
      colors: ['#6366F1', '#0EA5E9', '#22C55E', '#F97316'],
      legend: {
        position: 'bottom',
      },
      title: {
        text: 'Annual budget allocation',
        align: 'left',
      },
      plotOptions: {
        sunburst: {
          startAngle: -90,
          endAngle: 90,
          innerSize: '30%',
          borderRadius: 4,
          spacing: 2,
        },
      },
      stroke: {
        width: 1,
        colors: ['#fff'],
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="sunburst"
          height={360}
        />
      </div>
    </div>
  )
}

export default ApexChart